/* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <pthread.h>

#include "libnbd.h"
#include "internal.h"

int
nbd_set_debug (struct nbd_handle *h, bool debug)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_debug");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_set_debug (h, debug);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_get_debug (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_get_debug");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_get_debug (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_debug_callback (struct nbd_handle *h, int (*debug_fn) (unsigned valid_flag, void *user_data, const char *context, const char *msg), void *debug_fn_user_data)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_debug_callback");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_set_debug_callback (h, debug_fn, debug_fn_user_data);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
set_export_name_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_set_export_name (struct nbd_handle *h, const char *export_name)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_export_name");

  pthread_mutex_lock (&h->lock);
  if (!set_export_name_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_set_export_name (h, export_name);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

char *
nbd_get_export_name (struct nbd_handle *h)
{
  char *ret;

  nbd_internal_reset_error ("nbd_get_export_name");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_get_export_name (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
set_tls_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_set_tls (struct nbd_handle *h, int tls)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_tls");

  pthread_mutex_lock (&h->lock);
  if (!set_tls_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_set_tls (h, tls);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_get_tls (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_get_tls");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_get_tls (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
set_tls_certificates_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_set_tls_certificates (struct nbd_handle *h, const char *dir)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_tls_certificates");

  pthread_mutex_lock (&h->lock);
  if (!set_tls_certificates_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_set_tls_certificates (h, dir);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
set_tls_verify_peer_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_set_tls_verify_peer (struct nbd_handle *h, bool verify)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_tls_verify_peer");

  pthread_mutex_lock (&h->lock);
  if (!set_tls_verify_peer_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_set_tls_verify_peer (h, verify);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_get_tls_verify_peer (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_get_tls_verify_peer");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_get_tls_verify_peer (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
set_tls_username_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_set_tls_username (struct nbd_handle *h, const char *username)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_tls_username");

  pthread_mutex_lock (&h->lock);
  if (!set_tls_username_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_set_tls_username (h, username);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

char *
nbd_get_tls_username (struct nbd_handle *h)
{
  char *ret;

  nbd_internal_reset_error ("nbd_get_tls_username");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_get_tls_username (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
set_tls_psk_file_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_set_tls_psk_file (struct nbd_handle *h, const char *filename)
{
  int ret;

  nbd_internal_reset_error ("nbd_set_tls_psk_file");

  pthread_mutex_lock (&h->lock);
  if (!set_tls_psk_file_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_set_tls_psk_file (h, filename);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
add_meta_context_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_add_meta_context (struct nbd_handle *h, const char *name)
{
  int ret;

  nbd_internal_reset_error ("nbd_add_meta_context");

  pthread_mutex_lock (&h->lock);
  if (!add_meta_context_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_add_meta_context (h, name);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
connect_uri_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_connect_uri (struct nbd_handle *h, const char *uri)
{
  int ret;

  nbd_internal_reset_error ("nbd_connect_uri");

  pthread_mutex_lock (&h->lock);
  if (!connect_uri_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_connect_uri (h, uri);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
connect_unix_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_connect_unix (struct nbd_handle *h, const char *unixsocket)
{
  int ret;

  nbd_internal_reset_error ("nbd_connect_unix");

  pthread_mutex_lock (&h->lock);
  if (!connect_unix_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_connect_unix (h, unixsocket);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
connect_tcp_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_connect_tcp (struct nbd_handle *h, const char *hostname, const char *port)
{
  int ret;

  nbd_internal_reset_error ("nbd_connect_tcp");

  pthread_mutex_lock (&h->lock);
  if (!connect_tcp_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_connect_tcp (h, hostname, port);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
connect_command_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_connect_command (struct nbd_handle *h, char **argv)
{
  int ret;

  nbd_internal_reset_error ("nbd_connect_command");

  pthread_mutex_lock (&h->lock);
  if (!connect_command_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_connect_command (h, argv);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
read_only_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_read_only (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_read_only");

  pthread_mutex_lock (&h->lock);
  if (!read_only_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_read_only (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_flush_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_flush (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_flush");

  pthread_mutex_lock (&h->lock);
  if (!can_flush_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_flush (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_fua_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_fua (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_fua");

  pthread_mutex_lock (&h->lock);
  if (!can_fua_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_fua (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
is_rotational_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_is_rotational (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_is_rotational");

  pthread_mutex_lock (&h->lock);
  if (!is_rotational_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_is_rotational (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_trim_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_trim (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_trim");

  pthread_mutex_lock (&h->lock);
  if (!can_trim_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_trim (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_zero_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_zero (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_zero");

  pthread_mutex_lock (&h->lock);
  if (!can_zero_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_zero (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_df (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_df");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_can_df (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_multi_conn_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_multi_conn (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_multi_conn");

  pthread_mutex_lock (&h->lock);
  if (!can_multi_conn_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_multi_conn (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_cache_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_cache (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_cache");

  pthread_mutex_lock (&h->lock);
  if (!can_cache_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_cache (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
can_meta_context_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int
nbd_can_meta_context (struct nbd_handle *h, const char *metacontext)
{
  int ret;

  nbd_internal_reset_error ("nbd_can_meta_context");

  pthread_mutex_lock (&h->lock);
  if (!can_meta_context_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_can_meta_context (h, metacontext);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
get_size_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed");
    return false;
  }
  return true;
}

int64_t
nbd_get_size (struct nbd_handle *h)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_get_size");

  pthread_mutex_lock (&h->lock);
  if (!get_size_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_get_size (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
pread_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_pread (struct nbd_handle *h, void *buf, size_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_pread");

  pthread_mutex_lock (&h->lock);
  if (!pread_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_pread (h, buf, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
pread_structured_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_pread_structured (struct nbd_handle *h, void *buf, size_t count, uint64_t offset, int (*chunk) (unsigned valid_flag, void *user_data, const void *subbuf, size_t count, uint64_t offset, unsigned status, int *error), void *chunk_user_data, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_pread_structured");

  pthread_mutex_lock (&h->lock);
  if (!pread_structured_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_pread_structured (h, buf, count, offset, chunk, chunk_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
pwrite_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_pwrite (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_pwrite");

  pthread_mutex_lock (&h->lock);
  if (!pwrite_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_pwrite (h, buf, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
shutdown_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_shutdown (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_shutdown");

  pthread_mutex_lock (&h->lock);
  if (!shutdown_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_shutdown (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
flush_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_flush (struct nbd_handle *h, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_flush");

  pthread_mutex_lock (&h->lock);
  if (!flush_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_flush (h, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
trim_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_trim (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_trim");

  pthread_mutex_lock (&h->lock);
  if (!trim_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_trim (h, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
cache_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_cache (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_cache");

  pthread_mutex_lock (&h->lock);
  if (!cache_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_cache (h, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
zero_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_zero (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_zero");

  pthread_mutex_lock (&h->lock);
  if (!zero_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_zero (h, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
block_status_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_block_status (struct nbd_handle *h, uint64_t count, uint64_t offset, int (*extent) (unsigned valid_flag, void *user_data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error), void *extent_user_data, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_block_status");

  pthread_mutex_lock (&h->lock);
  if (!block_status_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_block_status (h, count, offset, extent, extent_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_poll (struct nbd_handle *h, int timeout)
{
  int ret;

  nbd_internal_reset_error ("nbd_poll");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_poll (h, timeout);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_connect_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_aio_connect (struct nbd_handle *h, const struct sockaddr *addr, socklen_t addrlen)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_connect");

  pthread_mutex_lock (&h->lock);
  if (!aio_connect_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_connect (h, addr, addrlen);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_connect_uri_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_aio_connect_uri (struct nbd_handle *h, const char *uri)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_connect_uri");

  pthread_mutex_lock (&h->lock);
  if (!aio_connect_uri_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_connect_uri (h, uri);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_connect_unix_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_aio_connect_unix (struct nbd_handle *h, const char *unixsocket)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_connect_unix");

  pthread_mutex_lock (&h->lock);
  if (!aio_connect_unix_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_connect_unix (h, unixsocket);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_connect_tcp_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_aio_connect_tcp (struct nbd_handle *h, const char *hostname, const char *port)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_connect_tcp");

  pthread_mutex_lock (&h->lock);
  if (!aio_connect_tcp_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_connect_tcp (h, hostname, port);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_connect_command_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_created (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "newly created");
    return false;
  }
  return true;
}

int
nbd_aio_connect_command (struct nbd_handle *h, char **argv)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_connect_command");

  pthread_mutex_lock (&h->lock);
  if (!aio_connect_command_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_connect_command (h, argv);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_pread_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_pread (struct nbd_handle *h, void *buf, size_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_pread");

  pthread_mutex_lock (&h->lock);
  if (!aio_pread_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_pread (h, buf, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_pread_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_pread_callback (struct nbd_handle *h, void *buf, size_t count, uint64_t offset, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_pread_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_pread_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_pread_callback (h, buf, count, offset, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_pread_structured_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_pread_structured (struct nbd_handle *h, void *buf, size_t count, uint64_t offset, int (*chunk) (unsigned valid_flag, void *user_data, const void *subbuf, size_t count, uint64_t offset, unsigned status, int *error), void *chunk_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_pread_structured");

  pthread_mutex_lock (&h->lock);
  if (!aio_pread_structured_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_pread_structured (h, buf, count, offset, chunk, chunk_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_pread_structured_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_pread_structured_callback (struct nbd_handle *h, void *buf, size_t count, uint64_t offset, int (*chunk) (unsigned valid_flag, void *user_data, const void *subbuf, size_t count, uint64_t offset, unsigned status, int *error), void *chunk_user_data, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_pread_structured_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_pread_structured_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_pread_structured_callback (h, buf, count, offset, chunk, chunk_user_data, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_pwrite_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_pwrite (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_pwrite");

  pthread_mutex_lock (&h->lock);
  if (!aio_pwrite_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_pwrite (h, buf, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_pwrite_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_pwrite_callback (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_pwrite_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_pwrite_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_pwrite_callback (h, buf, count, offset, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_disconnect_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int
nbd_aio_disconnect (struct nbd_handle *h, uint32_t flags)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_disconnect");

  pthread_mutex_lock (&h->lock);
  if (!aio_disconnect_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_disconnect (h, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_flush_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_flush (struct nbd_handle *h, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_flush");

  pthread_mutex_lock (&h->lock);
  if (!aio_flush_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_flush (h, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_flush_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_flush_callback (struct nbd_handle *h, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_flush_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_flush_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_flush_callback (h, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_trim_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_trim (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_trim");

  pthread_mutex_lock (&h->lock);
  if (!aio_trim_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_trim (h, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_trim_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_trim_callback (struct nbd_handle *h, uint64_t count, uint64_t offset, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_trim_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_trim_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_trim_callback (h, count, offset, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_cache_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_cache (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_cache");

  pthread_mutex_lock (&h->lock);
  if (!aio_cache_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_cache (h, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_cache_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_cache_callback (struct nbd_handle *h, uint64_t count, uint64_t offset, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_cache_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_cache_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_cache_callback (h, count, offset, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_zero_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_zero (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_zero");

  pthread_mutex_lock (&h->lock);
  if (!aio_zero_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_zero (h, count, offset, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_zero_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_zero_callback (struct nbd_handle *h, uint64_t count, uint64_t offset, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_zero_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_zero_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_zero_callback (h, count, offset, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_block_status_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_block_status (struct nbd_handle *h, uint64_t count, uint64_t offset, int (*extent) (unsigned valid_flag, void *user_data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error), void *extent_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_block_status");

  pthread_mutex_lock (&h->lock);
  if (!aio_block_status_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_block_status (h, count, offset, extent, extent_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_block_status_callback_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server");
    return false;
  }
  return true;
}

int64_t
nbd_aio_block_status_callback (struct nbd_handle *h, uint64_t count, uint64_t offset, int (*extent) (unsigned valid_flag, void *user_data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries, int *error), void *extent_user_data, int (*callback) (unsigned valid_flag, void *user_data, int64_t cookie, int *error), void *callback_user_data, uint32_t flags)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_block_status_callback");

  pthread_mutex_lock (&h->lock);
  if (!aio_block_status_callback_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_block_status_callback (h, count, offset, extent, extent_user_data, callback, callback_user_data, flags);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_get_fd (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_get_fd");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_aio_get_fd (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

unsigned
nbd_aio_get_direction (struct nbd_handle *h)
{
  unsigned ret;

  ret = nbd_unlocked_aio_get_direction (h);
  return ret;
}

int
nbd_aio_notify_read (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_notify_read");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_aio_notify_read (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_notify_write (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_notify_write");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_aio_notify_write (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_created (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_aio_is_created (h);
  return ret;
}

int
nbd_aio_is_connecting (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_aio_is_connecting (h);
  return ret;
}

int
nbd_aio_is_ready (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_aio_is_ready (h);
  return ret;
}

int
nbd_aio_is_processing (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_aio_is_processing (h);
  return ret;
}

int
nbd_aio_is_dead (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_aio_is_dead (h);
  return ret;
}

int
nbd_aio_is_closed (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_aio_is_closed (h);
  return ret;
}

int
nbd_aio_command_completed (struct nbd_handle *h, int64_t cookie)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_command_completed");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_aio_command_completed (h, cookie);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_peek_command_completed (struct nbd_handle *h)
{
  int64_t ret;

  nbd_internal_reset_error ("nbd_aio_peek_command_completed");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_aio_peek_command_completed (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

static inline bool
aio_in_flight_in_permitted_state (struct nbd_handle *h)
{
  const enum state state = get_public_state (h);

  if (!(nbd_internal_is_state_ready (state) || nbd_internal_is_state_processing (state) ||
        nbd_internal_is_state_closed (state) ||
        nbd_internal_is_state_dead (state))) {
    set_error (nbd_internal_is_state_created (state) ? ENOTCONN : EINVAL,
               "invalid state: %s: the handle must be %s",
               nbd_internal_state_short_string (state),
               "connected and finished handshaking with the server, or closed, or dead");
    return false;
  }
  return true;
}

int
nbd_aio_in_flight (struct nbd_handle *h)
{
  int ret;

  nbd_internal_reset_error ("nbd_aio_in_flight");

  pthread_mutex_lock (&h->lock);
  if (!aio_in_flight_in_permitted_state (h)) {
    ret = -1;
    goto out;
  }
  ret = nbd_unlocked_aio_in_flight (h);
 out:
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

const char *
nbd_connection_state (struct nbd_handle *h)
{
  const char *ret;

  nbd_internal_reset_error ("nbd_connection_state");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_connection_state (h);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

const char *
nbd_get_package_name (struct nbd_handle *h)
{
  const char *ret;

  ret = nbd_unlocked_get_package_name (h);
  return ret;
}

const char *
nbd_get_version (struct nbd_handle *h)
{
  const char *ret;

  ret = nbd_unlocked_get_version (h);
  return ret;
}

int
nbd_kill_command (struct nbd_handle *h, int signum)
{
  int ret;

  nbd_internal_reset_error ("nbd_kill_command");

  pthread_mutex_lock (&h->lock);
  ret = nbd_unlocked_kill_command (h, signum);
  if (h->public_state != get_next_state (h))
    h->public_state = get_next_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_supports_tls (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_supports_tls (h);
  return ret;
}

int
nbd_supports_uri (struct nbd_handle *h)
{
  int ret;

  ret = nbd_unlocked_supports_uri (h);
  return ret;
}

